#pragma once

#include "MemoSendAttachList.h"
#include "DUIControl.h"

#define WM_RESERVE_SELECT_CHANGED		(WM_USER + 24)
#define WM_EXPAND_CHANGED				(WM_USER + 36)
#define DEF_MEMOSEND_WND_HEIGHT			(209)
#define WPARAM_EXPAND_ON				(1)
#define WPARAM_EXPAND_OFF				(0)

#define DEF_MEMOSEND_ATTACH_BG_COLOR			Color(255, 255, 255, 255)
#define DEF_MEMOSEND_ATTACH_BGCENTERLINE_COLOR	/*(CColorConvert::HEX2Color(0x000000))*/(CColorConvert::HEX2Color(0xf3f3f3))
#define DEF_MEMOSEND_ATTACH_BGOUTLINE_COLOR		/*(CColorConvert::HEX2Color(0x000000))*/(CColorConvert::HEX2Color(0xc5cace))
#define DEF_MEMOSEND_ATTACH_PROGRESS_OUTLINE	Color(255, 180, 180, 180)

#define DEF_MEMOSEND_ATTACH_FONT_NAME			(g_defaultFontFaceName)
#define DEF_MEMOSEND_ATTACH_TITLE_FONT_HEIGHT	(9)
#define DEF_MEMOSEND_ATTACH_TITLE_FONT_COLOR	(CColorConvert::HEX2Color(0x010203))
#define DEF_MEMOSEND_ATTACH_TITLE_FONT_STYLE	(FontStyleBold)
#define DEF_MEMOSEND_ATTACH_KEY_FONT_HEIGHT		(9)
#define DEF_MEMOSEND_ATTACH_KEY_FONT_COLOR		(CColorConvert::HEX2Color(0x010203))
#define DEF_MEMOSEND_ATTACH_KEY_FONT_STYLE		(FontStyleBold)
#define DEF_MEMOSEND_ATTACH_VALUE_FONT_HEIGHT	(9)
#define DEF_MEMOSEND_ATTACH_VALUE_FONT_COLOR	(CColorConvert::HEX2Color(0x8d9398))
#define DEF_MEMOSEND_ATTACH_VALUE_FONT_STYLE	(FontStyleRegular)

#define DEF_MEMOSEND_TITLE_POS_LEFT_X				(16)
#define DEF_MEMOSEND_TITLE_POS_TOP_Y				(15)
#define DEF_MEMOSEND_KEY_POS_TOP_Y					(35)
#define DEF_MEMOSEND_SENDSPEED_VALUE_WIDTH			(100)
#define DEF_MEMOSEND_SENDSPEED_VALUE_HEIGHT			(7)
#define DEF_MEMOSEND_REMAINTIME_VALUE_WIDTH			(80)
#define DEF_MEMOSEND_CENTERLINE_POS_TOP_Y			(60)
#define DEF_MEMOSEND_FILEADD_POS_RIGHT_X			(16)
#define DEF_MEMOSEND_FILEADD_POS_TOP_Y				(10)
#define DEF_MEMOSEND_PROGRESS_POS_RIGHT_X			(18)
#define DEF_MEMOSEND_PROGRESS_POS_TOP_Y				(37)
#define DEF_MEMOSEND_PROGRESS_WIDTH					(100)
#define DEF_MEMOSEND_PROGRESS_HEIGHT				(7)
#define DEF_MEMOSEND_PROGRESS_TITLE_GAP				(6)
#define DEF_MEMOSEND_FILELIST_POS_LEFT_X			(20)
#define DEF_MEMOSEND_FILELIST_POS_TOP_Y				(46)
#define DEF_MEMOSEND_FILELIST_POS_TOP_Y2			(40)
#define DEF_MEMOSEND_FILELIST_POS_BOTTOM_Y			(31)
#define DEF_MEMOSEND_TOTAL_SPEED_HEIGHT				DEF_MEMOSEND_FILELIST_POS_BOTTOM_Y
#define DEF_MEMOSEND_TOTAL_SPEED_NAME_LEFT_X		(15)
#define DEF_MEMOSEND_TOTAL_SPEED_GAP				(4)
#define DEF_MEMOSEND_TOTAL_SPEED_TIME_GAP			(10)
#define DEF_MEMOSEND_TOTAL_TIME_GAP					(5)
#define DEF_MEMOSEND_TOTAL_RESERVE_RIGHT_X			(16)
#define DEF_MEMOSEND_TOTAL_RESERVE_GAP				(8)
#define DEF_MEMOSEND_TOTAL_RESERVE_PROGRESS_GAP		(15)
#define DEF_MEMOSEND_TOTAL_SENDSIZE_PROGRESS_GAP	(5)

#define ID_MEMO_SEND_ADD_BTN					(0x6021)
#define ID_MEMO_SEND_ATTACH_LIST				(0x6022)

class FileUploadController;

// CMemoSendAttachWnd

class CMemoFileDialog : public CFileDialog
{
	DECLARE_DYNAMIC(CMemoFileDialog)

public:
	CMemoFileDialog(CString str,CWnd* parent);
	virtual ~CMemoFileDialog();
public:
	void OnInitDone();
	CDialog* GetParentDialog();

public:
	BOOL m_bClose;
	CWnd* pParentWnd;
protected:
	DECLARE_MESSAGE_MAP()		
	
};

class CMemoSendAttachWnd : public CWnd, public IDUIEventCallBack
{
	DECLARE_DYNAMIC(CMemoSendAttachWnd)

public:
	CMemoSendAttachWnd();
	virtual ~CMemoSendAttachWnd();
	virtual void DUINotify(TNotifyUI& msg);
public:
	// BG
	Image*						m_pImgBG;
	Image*						m_pImgProgressBG[3];
	Image*						m_pImgProgressFG;

	Color						m_crBG;
	Color						m_crCenterline;
	Color						m_crOutline;
	Color						m_crProgressOutline;

	void						SetImgBGPath(CString strFileName);
	void						SetImgProgressPath(CString strFileNameFG,
								CString strFileNameBGl,
								CString strFileNameBGc,
								CString strFileNameBGr);

	// font
	WCHAR						m_wszFontName[64];
	REAL						m_nFontHeight;
	FontStyle					m_fontStyle;
	Color						m_crText;

	void						SetFontConfig(WCHAR* wszFontName, REAL nFontHeight, FontStyle style, Color crText);

	REAL						m_nFontHeightTitle;
	Color						m_crTitle;
	FontStyle					m_fontStyleTitle;

	REAL						m_nFontHeightKey;
	Color						m_crKey;
	FontStyle					m_fontStyleKey;

	REAL						m_nFontHeightValue;
	Color						m_crValue;	
	FontStyle					m_fontStyleValue;

	// dimension
	CRect						m_rtWnd;
	CRect						m_rtTitle;
	CRect						m_rcMyPC;
	CSize						m_szTitle;
	CSize						m_szMyPC;
	CSize						m_szReserve;
	CRect						m_rtSendSpeedTitle;
	CSize						m_szSendSpeedTitle;
	CRect						m_rtSendSpeedValue;
	CSize						m_szSendSpeedValue;
	CRect						m_rtRemainTimeTitle;
	CSize						m_szRemainTimeTitle;
	CRect						m_rtRemainTimeValue;
	CRect						m_rtFileSizeText;
	CRect						m_rtCurSendProgressText;
	CRect						m_rtTotalProgressText;
	CRect						m_rtFileSizeProgress;
	CRect						m_rtFileList;

	CString						m_strTitle;
	CString						m_strMyPC;
	CString						m_strSendSpeedTitle;
	CString						m_strSendSpeedValue;
	CString						m_strRemainTimeTitle;
	CString						m_strRemainTimeValue;
	ULONGLONG					m_dwTotalSize;
	ULONGLONG					m_dwCurSendSize;
	CString						m_strProgressSize;
	CString						m_strCurProgressSizeText;
	CString						m_strTotalSizeText;

	BOOL						m_bSendStart;
	COleDateTime				m_dtSendStart;

	void						SetTitle(CString strTitle);
	void						SetSendSpeedTitle(CString strSendSpeedTitle);
	void						SetSendSpeedValue(CString strSendSpeedValue);
	void						SetRemainTimeTitle(CString strRemainTimeTitle);
	void						SetRemainTimeValue(CString strRemainTimeValue);
	void						SetMyPCText(CString strMyPCValue);

	void						SetTotalSize(ULONGLONG dwTotalSize);
	void						SetCurSendSize(ULONGLONG dwCurSendSize);
	void						UpdateSize(ULONGLONG dwTotalSize, ULONGLONG dwCurSendSize);
	void						UpdateSpeed(ULONGLONG dwSendSize, double fSeconds);

	void						UpdateMemoSendSize();
	CPoint						ReSizeWindow(CPoint* pPtRightBottom);

	// child
	CDUIControl<CButtonUI>*		m_pBtnFileAdd;
	CDUIControl<CCheckBoxUI>*	m_pBtnExpand;
	CDUIControl<CCheckBoxUI>*	m_pCkBoxReserve;
	CMemoSendAttachList			m_listFileAttach;

	int							GetFileItemCount();
	void						AddForwardFileItem(CString strPath, CString strName, DWORD dwFileSize, int serverIndex);
	CMemoSendAttachList*		GetFileListCtrl()														{ return &m_listFileAttach; }
	void						UpdateFileAttachComplete(CString strPath);
	void						UpdateFileDelete(int nServerIndex);
	void						UpdateFileListDelete(int nServerIndex);
	void						UpdateFileAttachProgress(int index, DWORD dwSendLength);

	void						SetController(SendMemoController *pController);
	void						SetModel(CNoteModel *pModel);
	void						CloseModalDialog();
	void						SetReserveCheck(bool bCheck);
	bool						GetReserveCheck();


protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnPaint();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	void OnBtnFileAdd();
	afx_msg LRESULT OnUmMemosendFileSize(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT	OnFileSelected(WPARAM wParam, LPARAM lParam);

	void FileAdd(CString strFilePath);
	void __ResourceLoad(BOOL bInit = FALSE);
	void FileSendResultComplete(int index);
	void FileSendResultWait(int index);
	void ExpandAttachList(BOOL bExpand);
private:
	// select folder dialog is active
	//bool						m_bSelFileDlgIsActive;
	void _ReCalcTotalSpeedBar();
	void _DrawProgressBar(Graphics* pGraphics, double dbProgress, CRect *pRcProgress);
	void _DrawProgressText(Graphics* pGraphics, CRect* pRtPS);
	
	CMemoFileDialog* m_pFileDlg;
	BOOL m_bExpand;
};
